package com.gx.obe.common.widget.dialog;

import org.eclipse.swt.widgets.Shell;

import com.gx.obe.common.widget.rt.Tangent;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;

public class ProgressMessageTangent implements Tangent {
	
	private ProgressMessageDialog dialog;
	
	public ProgressMessageTangent(Shell parentShell, String title) {
		this.dialog = new ProgressMessageDialog(parentShell, false, -1, null);
		this.dialog.setTitle(title);
	}
	
	@Override
	public void before() {
		dialog.open();
	}
	
	@Override
	public void after() {
		dialog.finish(dialog.getErrorMessagesSize() == 0);
	}
	
	@Override
	public void error(Exception e) {
		dialog.message(e.getMessage(), -1);
		dialog.finish(false);
	}
	
}
