package com.gx.obe.common.widget.dialog;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.listener.SelectExpertListener;
import com.gx.obe.components.core.Constants;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.service.expert.ExpertService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 
 * @author guoyr
 */
public class SelectStepExpertDialog extends EDialog {

	private Grid memberGrid;
	private ExpertService expertService;
	private List<Expert> stepExpertUserIdList = new ArrayList<Expert>();
	private Composite customGroup;
	private String tenderId;
	private SelectExpertListener callBack;
	
	{
		LogUtils.logClass(SelectStepExpertDialog.class);
	}
	
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public SelectStepExpertDialog(Shell parentShell, String tenderId, List<Expert> stepExpertUserIdList, SelectExpertListener callBack) {
		super(parentShell);
		setTitle("选择自定议评标专家");
		this.tenderId = tenderId;
		// 为了不直接将来源数据修改
		if(null != stepExpertUserIdList){
			this.stepExpertUserIdList = stepExpertUserIdList;
		}
		this.callBack = callBack;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.horizontalSpacing = 0;
		gl_container.verticalSpacing = 1;
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);
		
		Composite composite_1 = new Composite(container, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayout(new GridLayout(1, false));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		
		CLabel label_3 = new CLabel(composite_1, SWT.NONE);
		label_3.setFont(SWTResourceManager.getFont("宋体", 10, SWT.BOLD));
		label_3.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/television.png"));
		label_3.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label_3.setText(Messages.EvalExpert);
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.marginHeight = 0;
		gl_composite_2.marginWidth = 0;
		composite_2.setLayout(gl_composite_2);
		
		memberGrid = new Grid(composite_2, SWT.V_SCROLL);
		memberGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		memberGrid.setHeaderVisible(true);
		
		GridColumn gridColumn_num = new GridColumn(memberGrid, SWT.CENTER);
		gridColumn_num.setText(Messages.Num);
		gridColumn_num.setWidth(50);
		gridColumn_num.setMaxmumWidth(60);
		
		GridColumn gridColumn_name = new GridColumn(memberGrid, SWT.CHECK);
		gridColumn_name.setText(Messages.FullName);
		gridColumn_name.setWidth(100);
		
		GridColumn gridColumn_account = new GridColumn(memberGrid, SWT.CENTER);
		gridColumn_account.setText(Messages.Account);
		gridColumn_account.setWidth(100);
		
		GridColumn gridColumn_type = new GridColumn(memberGrid, SWT.CENTER);
		gridColumn_type.setText(Messages.ExpertType);
		gridColumn_type.setWidth(250);
		
		customGroup = new Composite(container, SWT.NONE);
		customGroup.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		customGroup.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
//		customGroup.setText("已选择专家");
		customGroup.setLayout(new RowLayout(SWT.HORIZONTAL));
		GridData gd_customGroup = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_customGroup.heightHint = 30;
		customGroup.setLayoutData(gd_customGroup);
		
		Composite composite = new Composite(container, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setBackgroundMode(SWT.INHERIT_FORCE);
		composite.setLayout(new GridLayout(2, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		EButton button_1 = new EButton(composite, SWT.NONE);
		button_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/clear.png"));
		button_1.setText(Messages.Button_clear);
		button_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		button_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				clearStepExpert();
			}
		});
		
		EButton button = new EButton(composite, SWT.NONE);
		button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if(null != callBack){
					confirmAction();
				}
			}
		});
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/yes.png"));
		button.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		button.setText(Messages.Button_ok);
		
		init();
		return container;
	}

	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		expertService = new ExpertService();
		memberGrid.setItemHeight(Constants.ROW_HIGHT);
		// 为了避免脏数据
		List<Expert> tempExpertList = new ArrayList<Expert>();
		for(Control control : customGroup.getChildren()){
			control.dispose();
		}
		List<Expert> expertList = expertService.getExpertList(tenderId, null);
		if(null != expertList && expertList.size() > 0){
			int index = 1;
			for(Expert expert : expertList){
				if(null != expert.getUser()){
					GridItem gridItem = new GridItem(memberGrid, SWT.NONE);
					gridItem.setText(0, (index++)+"");
					gridItem.setText(1, ObjectUtils.getObjString(expert.getUser().getUserName()));
					gridItem.setText(2, ObjectUtils.getObjString(expert.getUser().getUserAccount()));
					gridItem.setText(3, expert.getExpertTypeAndRole());
					gridItem.setData("userId", expert.getUserId());
					gridItem.setData("expert", expert);
					if(expertContains(expert)){
						gridItem.setChecked(1, true);
						createStepExpert(expert);
						tempExpertList.add(expert);
					}else {
						gridItem.setChecked(1, false);
					}
				}
			}
			stepExpertUserIdList.clear();
			stepExpertUserIdList.addAll(tempExpertList);
		}
		
		// 添加选中监听事件
		memberGrid.addListener(SWT.Selection, new Listener(){
			public void handleEvent(Event event) {
				// 选中了复选框事件
				if(event.detail == SWT.CHECK){
					GridItem item = (GridItem)event.item;
					if(item.getChecked(1)){
						Expert expert = (Expert)item.getData("expert");
						createStepExpert(expert);
					}else {
						for(Control control : customGroup.getChildren()){
							ELink link = (ELink)control;
							String userId = (String)item.getData("userId");
							Expert expert = (Expert)item.getData("expert");
							if(ObjectUtils.equals((String)link.getData("userId"), userId)){
								stepExpertUserIdList.remove(expert);
								control.dispose();
								break;
							}
						}
						customGroup.layout();
					}
				}
			}
			
		});
	}
	
	private boolean expertContains(Expert expert){
		if(null == stepExpertUserIdList || stepExpertUserIdList.size()==0){
			return false;
		}
		for(Expert tempExpert :stepExpertUserIdList){
			if(StringUtils.equals(tempExpert.getId(), expert.getId())){
				return true;
			}
		}
		return false;
	}
	
	/**
	 * @Description: 创建已选择的自定义专家
	 * @author guoyr
	 * @param expert
	 */
	private void createStepExpert(final Expert expert){
		if(null != expert){
			final ELink link = new ELink(customGroup, SWT.NONE);
			link.setText(ObjectUtils.getObjString(expert.getUser().getUserName()));
			link.setData("userId", expert.getUserId());
			link.setData("expert", expert);
			stepExpertUserIdList.add(expert);
			link.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(MouseEvent e) {
					deleteStepExpert(link, expert.getUserId(), expert);
				}
			});
			customGroup.layout();
		}
	}
	
	/**
	 * @Description: 选中选择的自定义专家时删除
	 * @author guoyr
	 * @param userId
	 * @param expert 
	 */
	private void deleteStepExpert(ELink link, String userId, Expert expert){
		for(GridItem item : memberGrid.getItems()){
			if(ObjectUtils.equals((String)item.getData("userId"), userId)){
				item.setChecked(1, false);
			}
		}
		stepExpertUserIdList.remove(expert);
		link.dispose();
		customGroup.layout();
	}
	
	/**
	 * @Description: 清空自定义评标专家
	 * @author guoyr
	 */
	private void clearStepExpert(){
		for(Control control : customGroup.getChildren()){
			control.dispose();
		}
		stepExpertUserIdList.clear();
		GridUtils.checkAll(memberGrid, 1, false);
	}
	
	/**
	 * @Description: 确定
	 * @author guoyr
	 */
	private void confirmAction(){
		callBack.setExpertList(stepExpertUserIdList);
		getShell().close();
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(600, 400);
	}
}
