package com.gx.obe.common.widget.dialog;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Widget;

import com.gx.obe.common.widget.dialog.ProgressDialog;

/** 
 * @Description: 
 * @author chenxw 
 */
public abstract class ThreadProgressDialog extends ProgressDialog {
	
	private final Widget runWidget;

	/** 
	 * @author chenxw
	 * @param parent
	 * @param message 
	 */
	public ThreadProgressDialog(Shell parent, Widget runWidget, String message) {
		super(parent, message);
		this.runWidget = runWidget;
	}
	
	/** 
	 * @Description: 
	 * @author chenxw
	 * @return 
	 */
	@Override
	public Object open() {
		init();
		return super.open();
	}
	
	/**
	 * @Description: 
	 * @author chenxw 
	 */
	private void init() {
		new Thread(new Runnable() {
			public void run() {
				threadRun();
				Display display = Display.getDefault();
				if(null != display && !display.isDisposed()) {
					display.asyncExec(new Runnable() {
						public void run() {
							if (runWidget.isDisposed()) {
								return;
							}
							close();
							asyncExec();
						}
					});
				}
			}
		}).start();
	}
	
	/**
	 * @Description: 
	 * @author chenxw 
	 */
	public abstract void threadRun();
	
	/**
	 * @Description: 
	 * @author chenxw 
	 */
	public abstract void asyncExec();
	
}
